// lib.h

#ifndef __LIB_H__
#define __LIB_H__

#define ADR_SRAM     (u8*)0xE000000
#define ADR_EWRAM    (u8*)&__ewram_overlay_lma


//BG
void BGSetPal16(u16 *pal);
void BGSetPal256(u16 *pal);
void BGSetChrData(u8 No,u16 *img,u32 size);
void BGSetMapData(u8 No,u16 *img,u32 size);
void BGDrawStr(u8 BG,u8 x,u8 y,u8* str);



//Mode3
void Mode3DrawDot(u8 ,u8 ,u16);
void Mode3DrawBox(u8 ,u8 ,u8 ,u8 ,u16);
void Mode3DrawImage(u8 x, u8 y, u8 cx,u8 cy,u16* image);
//Mode3 Font BitMap
void Mode3SetBitMapFont(u8 *p, u16 cx, u16 cy, u16 cnt);
void Mode3DrawBitMapStr(u8 ,u8 ,u8*);
void Mode3DrawBitMapChar(u8 x,u8 y,u16 chr);
//Mode3 Font SJIS
void Mode3SetSJISFont(u32 code, u16 cnt, u32 offset, u8 cx, u8 cy);
void Mode3DrawSJISStr(u8 x,u8 y,u8* texts,u16 color);
void Mode3DrawSJISChar(u8 x, u8 y, u16 num, u16 col);
void Mode3DrawSJIS(u8 x, u8 y, u8* chr, u16 col); //2Bytep
void Mode3DrawSJISAscii(u8 x, u8 y, u16 num, u16 col);
void Mode3DrawSJISBlock(u8 font,int x1,int y1,u16 color);
//Mode3 Effect
//void Mode3DrawFadeOut();
//void Mode3DrawFadeIn();


//Sprite
void SpriteInitialize();
void SpriteSetPal16(u16 *pal);
void SpriteSetPal16No(u16 num, u16 palno);
void SpriteSetPal256(u16 *pal);
void SpriteSetData(u16 *img,u32 size);
void SpriteSetSize(u16 num,u16 size,u16 form,u16 color);
void SpriteSetChr(u16 num, u16 ch);
void SpriteMove(u16 num, s16 x, s16 y);



//Sound
void SoundInitialize();
void SoundSetData(s8 *buf, u32 wave_size);
void SoundStart();
void SoundStop();



//fobN
void dprint(u8 *sz);
int  dprintf(char *fmt, ...);



//DMA]
void DMA3MemcpyFIX16(u32, u32, u16);
void DMA3MemcpyINC16(u32, u32, u16);
void DMA3MemcpyINC32(u32, u32, u16);



//
void *_malloc(u32 size);
void _mfree(void *ptr);



//EFCg
void WaitPushA();



//̑
void WaitForVsync(void);
char *bprintf(char *p, char *fmt, ...);



// ExtendTinyFileSystem
u8* EtfsGetDataOffset(u32 data_offset);
u8* Etfsfopen(u32 offset, u32 size);
u8* EtfsfopenLZ77(u32 offset, u32 size);
u8  EtfsReadu8(u32);
u16 EtfsReadu16(u32);
u32 EtfsReadu32(u32);



typedef struct{
  u8  *offset;
  u16 size;
  u16 cx;
  u16 cy;
  u16 cnt;
} ST_FONTBITMAP;

typedef struct{
  u16 *Code;
  u8  *Offset;
  u16 size;
  u16 cx;
  u16 cy;
  u16 cnt;
} ST_FONTSJIS;

typedef struct{
  s8  *Offset;
  u32 size;
} ST_WAVE;

#endif
